from __future__ import division
#-------------------------------------------------------------------------------
# Name:        module1
# Purpose:
#
# Author:      ASUS
#
# Created:     29/03/2014
# Copyright:   (c) ASUS 2014
# Licence:     <your licence>
#-------------------------------------------------------------------------------
import sys, random, numpy, time, math, inspect, cProfile

def main():
    #initialise the global unused list, the 9 local unused lists and the game grid
    #defines how many rounds will be done at each level of iteration

    global use_decisive
    global use_weighted_simulations
    global use_weighted_smooth

    global AMAF
    global RAVE_cutoff
    global RAVE_smooth
    global Weighted_smart
    global RAVE_VISITS
    global RAVE_BIAS_HALF
    global RAVE_VISITS_500
    round_list=[300,60,30,15,10]
    nice_results=[]
    no_mode=True
    use_decisive=False
    use_weighted_simulations=False
    use_weighted_smooth=False
    RAVE_cutoff=False
    RAVE_smooth=False
    Weighted_smart=False
    mode_options=[0,0,0,0,0,0,0]
#SET THE ENHANCEMENTS. The values that i takes determines which enhancements will be used. 
#0-none
#1-decisive
#2-weighted 1/n
#3-weighted smooth
#4-RAVE cutoff
#5-Rave smooth
    for i in range (1,2):
        mode_options[i]=1
        for j in range (0,1):
            if j!=i:
                mode_options[j]=0
        if mode_options[0]==1:

            print("@@@No Enhancement")

        if mode_options[1]==1:
            use_decisive=True
            print("@@@Decisive")
        else:
            use_decisive=False
        if mode_options[2]==1:
            use_weighted_simulations=True
            print("@@@Weighted 1/n")
        else:
            use_weighted_simulations=False
        if mode_options[3]==1:
            use_weighted_smooth=True
            print("@@@Weighted smooth")
        else:
            use_weighted_smooth=False
        if mode_options[4]==1:
            RAVE_cutoff=True
            print("@@@RAVE cutoff")
        else:
            RAVE_cutoff=False
        if mode_options[5]==1:
            RAVE_smooth=True
            print("@@@RAVE smooth")
        else:
            RAVE_smooth=False
       


#CHOOSE THE SCENARIOS. The values of setting determine the scenarios which will be used
#See setup guide.txt for images of each of the scenarios
        #for setting in (1,2,3,4,5,6,7,11,12,17,18):
        for setting in range(6,7):
            round_index=0
            for iterations in (1000,5000,10000,20000,30000):
            
            
                if (iterations<30000 and setting ==-1):
                    round_index+=1
                else:
                    rounds=round_list[round_index]
                    round_index+=1


                    time_taken=0


                    results_grid=numpy.ndarray(shape=(3,3,3,3),dtype =int)
                    win_rate_grid=numpy.ndarray(shape=(3,3,rounds+1,2), dtype=float)
                    for i in (0,1,2):
                        for j in (0,1,2):
                            for k in range(0,rounds+1):
                                for l in(0,1):
                                    win_rate_grid[i,j,k,l]=-1
                            for k in (0,1,2):
                                for l in (0,1,2):
                                    results_grid[i,j,k,l]=0
                    correct_path_chosen=[0]
                    wrong_path_chosen=[0]
                    all_visits=[0]
                    for current_round in range (0,rounds):

                        game_grid=numpy.ndarray(shape=(6,3,6,3),dtype =int)
                        unused=[]
                        unused_grid=numpy.ndarray(shape=(3,3),dtype=list)
                        for i in range(0,6):
                            for j in  (0 ,1,2):
                                if i<3:
                                    unused_grid[i,j]=[]
                                for k in range(0,6):
                                    for l in (0,1,2):
                                        game_grid[i,j,k,l]=0
                                        if i<3 and k<3:
                                            unused.append((i,j,k,l))
                                            unused_grid[i,j].append((k,l))

                        #create the root node
                        root=node(None,unused,unused_grid, game_grid,-1,-1,1)
                        #set game to some specific setup (optional)


                        #----------------------------#
                        root=setup(root,setting)
                        #use_decisive=False
                        #use_weighted_simulations=False
                        AMAF=False
                        #RAVE=False
                        RAVE_VISITS=20
                        RAVE_VISITS_500=500
                        RAVE_BIAS_HALF=iterations/100

                        #----------------------------#
                        #print_big_wins(root.game_grid)
                        if AMAF and RAVE:
                            print("Cannot use AMAF and RAVE at the same time")
                            sys.exit()


                        if current_round==0:
                            print("Initial Board position for this run: ")
                            print_game(root.game_grid)
                            print("Iterations: ", iterations)

                        #print("Round ", current_round+1)
                        global its_so_far
                        its_so_far=0
                        start_time=time.time()
                        global count
                        count=0
                        for iteration in range (0,iterations):

                            its_so_far+=1
                            #if(its_so_far%100==0):
                                #print_visits(root)
                            MCTS(root)


                        end_time=time.time()

                        time_taken+=(end_time-start_time)

                        #a 0 flag in these methods suppresses the output and just returns the most visited/highest average reward move
                        chosen_move=print_most_visited(root,0)
                        chosen_move=print_best_visited(root,0)

                        if chosen_move==-1:
                            print("The game grid was full to begin with, so no MCTS could be performed")
                            break
                        #update the results grid with the chosen move
                        results_grid[chosen_move]+=1
                        #contains the number of visits to each node along to optimal move path

                        correct_path_visits = check_path(root,correct_path)


                        all_visits=get_visits_depth(root,correct_path.__len__(),all_visits)

                        #if this conditional is true, we are in a run where we chose the right move. Increment the number of times we chose the right move, and add the number of times we visited the end of the move chain
                        if chosen_move==correct_path[0]:
                            correct_path_chosen[0]+=1
                            correct_path_chosen.append(correct_path_visits[correct_path_visits.__len__()-1])
                        #otherwise, do the same but add it to the list which stores the number of times we visited the right move, given that we chose the wrong move
                        else:
                            wrong_path_chosen[0]+=1
                            wrong_path_chosen.append(correct_path_visits[correct_path_visits.__len__()-1])

                        update_win_rates(win_rate_grid, current_round, root.active_row,root.active_col,root)
                        #print_visits(root)

                    print_results(results_grid,setting)
                    #print_all_winrates(root)




                    for i in(0,1,2):
                        for j in(0,1,2):
                            sum1=0
                            sum2=0
                            for k in range (0,rounds):
                                sum1=sum1+win_rate_grid[i,j,k,0]
                                sum2=sum2+win_rate_grid[i,j,k,1]
                            win_rate_grid[i,j,rounds,0]=sum1/rounds
                            win_rate_grid[i,j,rounds,1]=sum2/rounds


                    if all_visits[0]>0:
                        average_visits=sum(all_visits[1:])/all_visits[0]
                    else:
                        average_visits=0
                    n=0
                    current_node=root

                    #print("PATH VISITS")
                    #while n<correct_path.__len__():
                        
                    #    print("printing visits")
                    #    print_game(current_node.game_grid)
                     #   print_grid(current_node.game_grid)
                     #   print("The Move:",check_decisive_whole_grid(current_node))
                     #   current_node=current_node.children[(correct_path[n])]
                     #   print("done")
                    #    n=n+1
                    print("Average win rates for the entire run (-1 indicates that this move was already used in the initial setup)")
                    print(win_rate_grid[:,:,rounds,0])
                    print("Average expected value for the entire run (-1 indicates that this move was already used in the initial setup)")
                    print(win_rate_grid[:,:,rounds,1])
                    print("When choosing the CORRECT move, the number of times the final node in the correct sequence was reached were:")
                    print(correct_path_chosen[1:])
                    correct_correct=0
                    wrong_correct=0
                    if len(correct_path_chosen)>1:
                        print("When choosing a CORRECT move, the average number of times the final node in the correct sequence was reached was:")
                        print(sum(correct_path_chosen[1:])/correct_path_chosen[0])
                        correct_correct=sum(correct_path_chosen[1:])/correct_path_chosen[0]
                    print("When choosing an INCORRECT move, the number of times the final node in the correct sequence was reached were:")
                    print(wrong_path_chosen[1:])

                    if len(wrong_path_chosen)>1:
                        print("When choosing an INCORRECT move, the average number of times the final node in the correct sequence was reached was:")
                        print(sum(wrong_path_chosen[1:])/wrong_path_chosen[0])
                        wrong_correct=sum(wrong_path_chosen[1:])/wrong_path_chosen[0]

                    #print("The average number of visits to nodes at the same depth as the final move in the correct sequence was:")
                    #print(average_visits)

                    print("Time taken: ",time_taken, " Average time per iteration: ", time_taken/(iterations*rounds))


                    #print("Initial Board position for this run: ")
                    #print_game(root.game_grid)


                    for i in range (0,int(math.ceil(40/(len(str(setting))+1)))):
                        print(setting,end=" ")
                    print()
                    print("----------------------------------------")

                    if abs(root.game_grid[5,2,5,2])>1:
                        print("Game over in start position, winner is: ", root.game_grid[5,2,5,2])

                    nice_vector=(correct_path_chosen[0],correct_correct,wrong_correct,average_visits,time_taken/(iterations*rounds),time_taken)
                    nice_results.append(nice_vector)

            
            print(nice_results)

class node():


    def __init__(self,parent_new,unused_new,unused_grid_new, game_grid_new,active_row_new,active_col_new,new_player_to_move):
        self.move_just_made=None
        self.visits=0
        self.player_to_move=new_player_to_move
        self.x_wins=0
        self.exp_reward=0
        self.AMAF_reward=0
        self.AMAF_visits=0
        self.o_wins=0
        self.draws=0
        self.unused=list(unused_new)
        self.unused_grid=unused_grid_new.copy()
        self.parent = parent_new
        self.game_grid=game_grid_new.copy()
        self.active_row=active_row_new
        self.active_col=active_col_new
        self.children=numpy.ndarray(shape=(3,3,3,3),dtype=node)
        for i in(0,1,2):
            for j in (0,1,2):
                for k in(0,1,2):
                    for l in (0,1,2):
                        self.children[i,j,k,l]=None
        self.ucb_val=0


    #returns a random move from the active grid

    def update_ucb_vals(self):

        if RAVE_smooth or RAVE_cutoff:
            if RAVE_smooth:
                rave_value=math.sqrt(RAVE_BIAS_HALF/(3*its_so_far+RAVE_BIAS_HALF))
            for i in (0,1,2):
                for j in (0,1,2):
                    for k in (0,1,2):
                        for l in (0,1,2):
                            if self.children[i,j,k,l] is not None:
                                #rave_value=0
                                if RAVE_cutoff:
                                    rave_value=max(0,(RAVE_VISITS-self.children[i,j,k,l].visits)/RAVE_VISITS)
                                


                                if self.children[i,j,k,l].AMAF_visits==0:
                                    if self.player_to_move==1:

                                        self.children[i,j,k,l].ucb_val=(1-rave_value)*self.children[i,j,k,l].exp_reward/self.children[i,j,k,l].visits+(math.sqrt(2))*math.sqrt(2*math.log(its_so_far)/self.children[i,j,k,l].visits)
                                        #print("NO AMAF X to move (",k,l,") :", self.children[i,j,k,l].ucb_val)
                                    if self.player_to_move==-1:
                                        self.children[i,j,k,l].ucb_val=1-((1-rave_value)*self.children[i,j,k,l].exp_reward/self.children[i,j,k,l].visits)+(math.sqrt(2))*math.sqrt(2*math.log(its_so_far)/self.children[i,j,k,l].visits)
                                        #print("NO AMAF O to move (",k,l,") :", self.children[i,j,k,l].ucb_val)

                                else:
                                    if self.player_to_move==1:

                                        self.children[i,j,k,l].ucb_val=((1-rave_value)*(self.children[i,j,k,l].exp_reward/self.children[i,j,k,l].visits))+(rave_value*(self.children[i,j,k,l].AMAF_reward)/self.children[i,j,k,l].AMAF_visits)+(math.sqrt(2)*math.sqrt(2*math.log(its_so_far)/self.children[i,j,k,l].visits))
                                        #print("X to move (",k,l,") :", self.children[i,j,k,l].ucb_val)
                                    if self.player_to_move==-1:
                                        self.children[i,j,k,l].ucb_val=1-((1-rave_value)*(self.children[i,j,k,l].exp_reward/self.children[i,j,k,l].visits))+(rave_value*(self.children[i,j,k,l].AMAF_reward)/self.children[i,j,k,l].AMAF_visits)+(math.sqrt(2)*math.sqrt(2*math.log(its_so_far)/self.children[i,j,k,l].visits))
                                        #print("O to move (",k,l,") :", self.children[i,j,k,l].ucb_val)


        else:
            for i in (0,1,2):
                for j in (0,1,2):
                    for k in (0,1,2):
                        for l in (0,1,2):
                            if self.children[i,j,k,l] is not None:
                                if self.player_to_move==1:
                                    self.children[i,j,k,l].ucb_val=self.children[i,j,k,l].exp_reward/self.children[i,j,k,l].visits+(math.sqrt(2))*math.sqrt(2*math.log(its_so_far)/self.children[i,j,k,l].visits)
                                if self.player_to_move==-1:
                                    self.children[i,j,k,l].ucb_val=1-(self.children[i,j,k,l].exp_reward/self.children[i,j,k,l].visits)+(math.sqrt(2))*math.sqrt(2*math.log(its_so_far)/self.children[i,j,k,l].visits)

    def get_random_move(self):
        if self.active_row ==-1:
            length=self.unused.__len__()

            random_move_index = random.randint(0,length-1)
            move = self.unused[random_move_index]

        else:
            random_list = self.unused_grid[self.active_row,self.active_col]
            end=random_list.__len__()
            end=end-1
            if end==1:
                random_move_index=0
            else:
                random_move_index = random.randint(0,end)
            move= (self.active_row,self.active_col,random_list[random_move_index][0],random_list[random_move_index][1])

        return move

    def get_ucb_move(self):
        self.update_ucb_vals()
        max_ucb=-100
        current_best_move=None
        if self.active_row==-1:
            length=self.unused.__len__()
            if length-1 ==0:
                return self.unused[0]
            else:
                for i in range (0,length):
                    current_move=self.unused[i]
                    if self.children[current_move] is None:
                        return current_move
                    elif self.children[current_move].ucb_val>max_ucb:
                        max_ucb=self.children[current_move].ucb_val
                        current_best_move=current_move
                return current_best_move

        else:
            length=self.unused_grid[self.active_row,self.active_col].__len__()
            if length-1==0:
                return (self.active_row, self.active_col, self.unused_grid[self.active_row,self.active_col][0][0],self.unused_grid[self.active_row,self.active_col][0][1])
            else:
                for i in range (0,length):
                    current_move=self.unused_grid[self.active_row,self.active_col][i]
                    if self.children[self.active_row,self.active_col,current_move[0],current_move[1]] is None:
                        return (self.active_row,self.active_col,current_move[0],current_move[1])
                    elif self.children[self.active_row,self.active_col,current_move[0],current_move[1]].ucb_val>max_ucb:
                        max_ucb=self.children[self.active_row,self.active_col,current_move[0],current_move[1]].ucb_val
                        current_best_move=(self.active_row,self.active_col,current_move[0],current_move[1])
                return current_best_move


    #run a random game from the position in children[move]
    #TODO
    def random_game(self,move):
        global decisive
        global move_count
        decisive=False

        x_moves=[]
        o_moves=[]
        if self.player_to_move==1:
            x_moves.append(move)
        else:
            o_moves.append(move)
        global length
        length=0
        move_count=81-self.unused.__len__()
        game_won=False
        #runs the move that was given to random_game
        winner=self.update_game_grid(move)
        length+=1
        self.player_to_move=-self.player_to_move
        if winner==2 or winner==-2 or winner==3:
            game_won=True
        #runs more moves until the game is over
        while game_won == False:
            move_count=move_count+1
            

            if use_decisive:
                
                move = check_decisive_whole_grid(self)

                if move ==None:
                    move=self.get_random_move()
                    decisive=False
            else:
                move=self.get_random_move()
            if self.player_to_move==1:
                x_moves.append(move)
            else:
                o_moves.append(move)
            winner=self.update_game_grid(move)
            length+=1
            self.player_to_move=-self.player_to_move
            if winner==2 or winner==-2 or winner==3:
                game_won=True
        if winner==2 or winner ==-2:
            return (winner/2,length,x_moves,o_moves)
        else:
            return (0,length,x_moves,o_moves)


    #retrns true if there is a child created by that move, and false otherwise
    def has_child(self, move):

        if self.children[move]==None:
            return False
        else:
            return True

    def get_child(self,move):
        return self.children[move]

    #makes a child at that move location
    def make_child(self,move):


        #update the game grid of the child using the move that takes us from the parent to the child, and the active row and col of the parent.
        #then set the active row and col of the child to the new values that they would take after the move that took us to the child has been made
        self.children[move]=copy(self)
        child_node=self.children[move]
        child_node.parent=self
        child_node.move_just_made=move
        has_player_won=child_node.update_game_grid(move)
        #important to change the player after updating the game, since the game needs to be updated with the player of the parent making their move
        child_node.player_to_move=-child_node.player_to_move
        i=move[2]
        j=move[3]

        if child_node.game_grid[i,j,5,2]==3 or child_node.game_grid[i,j,5,2]==2 or child_node.game_grid[i,j,5,2]==-2:
            child_node.active_col=-1
            child_node.active_row=-1
        else:
            child_node.active_row=i
            child_node.active_col=j
        return has_player_won



    def update_game_grid(self,move):


        #if the return code is 0, no one has won
        #if is is 1 or -1, that indicates that a player has won a small board
        #if it is 2 or -2, that indicates that a player has won the game
        #if it is 3, the game is over but no one has won. i.e a draw

        return_code=0
        a=move[0]
        b=move[1]
        i=move[2]
        j=move[3]
        #get rid of the move from the "possible move" lists


        try:
            self.unused.remove((a,b,i,j))
        except Exception:
            print("failed to remove from unused")
            print((a,b,i,j))
            print(move)
            print(self.unused)
            print_game(self.game_grid)
            print("Move count after: ",move_count)
            print("length",length)
            if decisive:
                print("DECISIVE!!!")
        try:
            self.unused_grid[a,b].remove((i,j))
        except Exception:
            print("failed to remove from grid")
            print((a,b,i,j))
            print(self.unused_grid[a,b])
            print_game(self.game_grid)
            print("Move count after: ",move_count)


        #NOTE:  GAME_GRID[A,B,5,2] stores the win value of the mini grid [a,b].
        #1, -1 indicate wins but not full. 2,-2 indicate full wins. 3 indicates a full draw
        #the indices (0-2,0-2,0-2,0-6) are used to store small square values and their won value
        #which is effectively a large O or X.
        # (3,0-2,0,0) and (4,0-2,0,0) are used for large row and col scores. (5,0,5,0) and (5,1,0,0) are used for diagonals
        #this leaves 5,2,5,2 to score the whole grid

        #the target value to indicate that the square is won
        won_amount=self.player_to_move*3
        #will be true if a small box was just won
        just_won=False

        self.game_grid[a,b,i,j]=self.player_to_move
        #test for diagonal on the small board
        little_TL_diagonal=False
        little_BL_diagonal=False
        if i==j:
            little_TL_diagonal=True
        if (i+j)==2:
            little_BL_diagonal=True
        big_TL_diagonal=False
        big_BL_diagonal=False
        if a==b:
            big_TL_diagonal=True
        if (a+b)==2:
            big_BL_diagonal=True
        self.game_grid[a,b,3,i]+=self.player_to_move
        self.game_grid[a,b,4,j]+=self.player_to_move
        #if the player has won the small board, update the small grid to show that
        #make sure the cell is not already won
        if (self.game_grid[a,b,3,i]==won_amount or self.game_grid[a,b,4,j]==won_amount) and self.game_grid[a,b,5,2]==0:
            self.game_grid[a,b,5,2]=self.player_to_move
            just_won=True
            return_code = self.player_to_move

        #if the move was on the top left diagonal
        if little_TL_diagonal:
            self.game_grid[a,b,5,0]+=self.player_to_move
            #make sure the cell is not already won
            if self.game_grid[a,b,5,0]==won_amount and self.game_grid[a,b,5,2]==0:
                self.game_grid[a,b,5,2]=self.player_to_move
                just_won=True
                return_code = self.player_to_move
        #if the move was on the bottom left diagonal
        if little_BL_diagonal:
            self.game_grid[a,b,5,1]+=self.player_to_move
            #make sure the cell is not already won
            if self.game_grid[a,b,5,1]==won_amount  and self.game_grid[a,b,5,2]==0:
                self.game_grid[a,b,5,2]=self.player_to_move
                just_won=True
                return_code = self.player_to_move
        #if the grid in question is full and has not been won, set it to 3 indicating a draw. If it has been won, set it to 2 times the won value
        if not self.unused_grid[a,b]:
            if self.game_grid[a,b,5,2]==0:
                self.game_grid[a,b,5,2]=3
                #change the big row and col scores to non-int values to indicate a draw in that row/col
                self.game_grid[3,a,0,0]+=10
                self.game_grid[4,b,0,0]+=10
                if big_TL_diagonal:
                    self.game_grid[5,0,5,0]+=10
                if big_BL_diagonal:
                    self.game_grid[5,1,0,0]+=10
            else:
                self.game_grid[a,b,5,2]=2*self.game_grid[a,b,5,2]





       #if the small square was won, test the whole board, change active row/col
        if just_won:



            #update the big board
            self.game_grid[3,a,0,0]+=self.player_to_move
            self.game_grid[4,b,0,0]+=self.player_to_move
            #if the player won by row or col
            if self.game_grid[3,a,0,0]==won_amount or self.game_grid[4,b,0,0]==won_amount:
                game_won=self.player_to_move
                return_code = self.player_to_move*2
            #if the move was on the top left diagonal
            if big_TL_diagonal:
                self.game_grid[5,0,5,0]+=self.player_to_move
                if self.game_grid[5,0,5,0]==won_amount:
                    game_won=self.player_to_move
                    return_code = self.player_to_move*2
            #if the move was on the bottom left diagonal
            if big_BL_diagonal:
                self.game_grid[5,1,0,0]+=self.player_to_move
                if self.game_grid[5,1,0,0]==won_amount:
                    game_won=self.player_to_move
                    return_code = self.player_to_move*2
        #check if the whole game is a draw
        if not self.unused:
            return_code=3
        #if the place you are sending to next is a draw or full, dont send there

        if self.game_grid[i,j,5,2]==3 or self.game_grid[i,j,5,2]==2 or self.game_grid[i,j,5,2]==-2:
            self.active_col=-1
            self.active_row=-1
        else:
            self.active_row=i
            self.active_col=j
        if self.game_grid[5,2,5,2]==0 and abs(return_code)>1:
            self.game_grid[5,2,5,2]=return_code
        return return_code



    def get_unused(self):
        return unused
    def get_unused_grid(self):
        return unused_grid
    def get_game_grid(self):
        return game_grid

#creates a deep copy of a node
def copy(original):
        new_unused_grid=numpy.ndarray(shape=(3,3),dtype=list)
        for i in (0,1,2):
            for j in(0,1,2):
                new_unused_grid[i,j]=list(original.unused_grid[i,j])
        copy_node=node(None, list(original.unused),new_unused_grid,original.game_grid.copy(),int(original.active_row),int(original.active_col),int(original.player_to_move))
        return copy_node

#prints a grid with X and O
def print_game(game_grid):

        for i in (0,1,2):
            for j in(0,1,2):
                for k in(0,1,2):
                    for l in(0,1,2):
                        if game_grid[i,k,j,l]==1:
                            print("X",end="")
                        elif game_grid[i,k,j,l]==-1:
                            print("O",end="")
                        else:
                            print("_",end="")

                    print(" ",end="")

                print()
            print()

def print_grid(game_grid):
    for j in(0,1,2):
        for i in(0,1,2,3,4,5):
            print("Row ",i,"Col " ,j)
            print(game_grid[i,j,:,:])

def backpropogate(current_node,winner):


    current_node.visits+=1
    winner_temp=(winner+1)/2
    if winner_temp>.5:
        current_node.x_wins+=1
        current_node.exp_reward+=winner_temp
    if winner_temp<.5:
        current_node.o_wins+=1
        current_node.exp_reward+=winner_temp
    if winner_temp==.5:
        current_node.draws+=1
        current_node.exp_reward+=winner_temp
    if current_node.parent is not None:
        backpropogate(current_node.parent,winner)

def AMAF_backpropogate(current_node,winner,moves):
    winner_temp=(winner+1)/2
    if current_node.parent!=None:
        current_node.visits+=1
        if winner_temp>.5:
            current_node.x_wins+=1
            current_node.exp_reward+=winner_temp
        if winner_temp<.5:
            current_node.o_wins+=1
            current_node.exp_reward+=winner_temp
        if winner_temp ==.5:
            current_node.draws+=1
            current_node.exp_reward+=winner_temp
        parent_node=current_node.parent
        for i in(0,1,2):
            for j in(0,1,2):
                for k in(0,1,2):
                    for l in(0,1,2):
                        if parent_node.children[i,j,k,l] != None:

                            if parent_node.children[i,j,k,l].move_just_made in moves:

                                parent_node.children[i,j,k,l].visits+=1
                                if winner_temp>.5:
                                    parent_node.children[i,j,k,l].x_wins+=1
                                    parent_node.children[i,j,k,l].exp_reward+=winner_temp
                                if winner_temp<.5:
                                    parent_node.children[i,j,k,l].o_wins+=1
                                    parent_node.children[i,j,k,l].exp_reward+=winner_temp
                                if winner_temp ==.5:
                                    parent_node.children[i,j,k,l].draws+=1
                                    parent_node.children[i,j,k,l].exp_reward+=winner_temp
        AMAF_backpropogate(parent_node,winner,moves)

def RAVE_backpropogate(current_node,winner,x_moves,o_moves):
    player_moving=current_node.player_to_move
    winner_temp=(winner+1)/2
    if current_node.parent!=None:
        current_node.visits+=1
        if winner_temp>.5:
            current_node.x_wins+=1
            current_node.exp_reward+=winner_temp
        if winner_temp<.5:
            current_node.o_wins+=1
            current_node.exp_reward+=winner_temp
        if winner_temp ==.5:
            current_node.draws+=1
            current_node.exp_reward+=winner_temp
        parent_node=current_node.parent
        for i in(0,1,2):
            for j in(0,1,2):
                for k in(0,1,2):
                    for l in(0,1,2):
                        if parent_node.children[i,j,k,l] != None:
                            if player_moving==1:

                                if parent_node.children[i,j,k,l].move_just_made in o_moves and parent_node.children[i,j,k,l] is not current_node:
                                    parent_node.children[i,j,k,l].AMAF_visits+=1
                                    parent_node.children[i,j,k,l].AMAF_reward+=winner_temp
                            else:
                                if parent_node.children[i,j,k,l].move_just_made in x_moves and parent_node.children[i,j,k,l] is not current_node:
                                    parent_node.children[i,j,k,l].AMAF_visits+=1
                                    parent_node.children[i,j,k,l].AMAF_reward+=winner_temp
        RAVE_backpropogate(parent_node,winner,x_moves,o_moves)
    else:
        backpropogate(current_node,winner)

def print_all_visits(current_node):
    print("visits: ",current_node.visits," X wins: ", current_node.x_wins," O wins: ",current_node.o_wins," Draws: ",current_node.draws)
    print_game(current_node.game_grid)
    for i in (0,1,2):
        for j in (0,1,2):
            for k in (0,1,2):
                for l in (0,1,2):
                    if current_node.children[i,j,k,l] is not None:
                        print_visits(current_node.children[i,j,k,l])

def print_visits(current_node):
    print("visits: ",current_node.visits," X wins: ", current_node.x_wins," O wins: ",current_node.o_wins," Draws: ",current_node.draws)
    print_game(current_node.game_grid)
    for i in (0,1,2):
        for j in (0,1,2):
            for k in (0,1,2):
                for l in (0,1,2):
                    if current_node.children[i,j,k,l] is not None:
                        print("visits: ",current_node.children[i,j,k,l].visits," X wins: ", current_node.children[i,j,k,l].x_wins," O wins: ",current_node.children[i,j,k,l].o_wins," Draws: ",current_node.children[i,j,k,l].draws)
                        print_game(current_node.children[i,j,k,l].game_grid)

def print_most_visited(current_node,mode):
    max_visits=0
    win_rate=0
    move=None
    for i in (0,1,2):
        for j in (0,1,2):
            for k in (0,1,2):
                for l in (0,1,2):
                    if current_node.children[i,j,k,l] is not None:
                        current_visits=current_node.children[i,j,k,l].visits
                        if current_visits>max_visits:
                            max_visits=current_visits
                            move=(i,j,k,l)
                            win_rate=current_node.children[i,j,k,l].x_wins/current_visits
    if mode==1:
        print("Most visited move is: ", move, " With ", max_visits, " visits")
        print("Win rate was ", win_rate)
        return move

def print_best_visited(current_node,mode):
    max_reward=0
    move=None
    visit_count=0
    for i in (0,1,2):
        for j in (0,1,2):
            for k in (0,1,2):
                for l in (0,1,2):
                    if current_node.children[i,j,k,l] is not None:


                        current_reward=current_node.children[i,j,k,l].exp_reward/current_node.children[i,j,k,l].visits
                        if move is None:
                            max_reward=current_reward
                            move=(i,j,k,l)
                            visit_count=current_node.children[i,j,k,l].visits
                        elif current_reward>=max_reward:
                            max_reward=current_reward
                            move=(i,j,k,l)
                            visit_count=current_node.children[i,j,k,l].visits
    if move==None:
        return -1
    if mode==1:
        print("Most valuable move is: ", move, " With ", max_reward, " average reward")
        print("Root stats. Wins: ", current_node.x_wins, " Losses: ", current_node.o_wins, " Draws: ",current_node.draws)
        print("Chosen move stats. Wins: ", current_node.children[move].x_wins, " Losses: ", current_node.children[move].o_wins, " Draws: ",current_node.children[move].draws)
        print("Visit count was ", visit_count)
    return move

def print_all_winrates(current_node):
    print("Wins/visits")
    for i in (0,1,2):
        for j in (0,1,2):
            for k in (0,1,2):
                for l in (0,1,2):
                    if current_node.children[i,k,j,l] is not None:
                        print(round(current_node.children[i,k,j,l].x_wins/current_node.children[i,k,j,l].visits,4), end=" ")
                    else:
                        print("NA" ,end=" ")
                print("      " ,end="")
            print()
        print()
    print("Average Expected reward")
    for i in (0,1,2):
        for j in (0,1,2):
            for k in (0,1,2):
                for l in (0,1,2):
                    if current_node.children[i,k,j,l] is not None:
                        print(round(current_node.children[i,k,j,l].exp_reward/current_node.children[i,k,j,l].visits,4), end=" ")
                    else:
                        print("NA" ,end=" ")
                print("      " ,end="")
            print()
        print()
    print("AMAF reward")
    for i in (0,1,2):
        for j in (0,1,2):
            for k in (0,1,2):
                for l in (0,1,2):
                    if current_node.children[i,k,j,l] is not None:
                        print(round(current_node.children[i,k,j,l].AMAF_reward,4), end=" ")
                    else:
                        print("NA" ,end=" ")
                print("      " ,end="")
            print()
        print()
    print("AMAF visits")
    for i in (0,1,2):
        for j in (0,1,2):
            for k in (0,1,2):
                for l in (0,1,2):
                    if current_node.children[i,k,j,l] is not None:
                        print(round(current_node.children[i,k,j,l].AMAF_visits,4), end=" ")
                    else:
                        print("NA" ,end=" ")
                print("      " ,end="")
            print()
        print()

#only works when starting moves are all in one box
def update_win_rates(grid,round,row,col,current_node):
    if row==-1:
        pass
    else:
        for i in(0,1,2):
            for j in(0,1,2):
                if current_node.game_grid[row,col,i,j]==0:
                    grid[i,j,round,0]=current_node.children[row,col,i,j].x_wins/current_node.children[row,col,i,j].visits
                    grid[i,j,round,1]=current_node.children[row,col,i,j].exp_reward/current_node.children[row,col,i,j].visits

def print_results(results_grid,setting):
    print("Board Setup: ", setting)
    print("Initial move choice Frequency")
    for i in (0,1,2):
        for j in(0,1,2):
            for k in(0,1,2):
                for l in(0,1,2):
                    print(results_grid[i,k,j,l]," ",end="")

                print(" ",end="")

            print()
        print()
    print("Initial move choice Frequency")
    for i in(0,1,2):
        for j in(0,1,2):
            print(results_grid[2,0,i,j]," ", end = "")
        print()

def print_big_wins(game_grid):
    print("Initial won boards")
    for i in(0,1,2):
        for j in(0,1,2):
            print(game_grid[i,j,5,2], end=" ")
        print()
    print("Game won? ", game_grid[5,2,5,2])

def setup(node,setting):

    global correct_path
   #15 free 3 step sacrifice to win, x only
    if setting ==1:
        correct_path=[(2,0,2,2),(2,2,2,2),(0,2,0,2)]
        node.player_to_move=1
        node.update_game_grid((1,0,0,0))
        node.update_game_grid((1,0,0,2))
        node.update_game_grid((1,0,1,0))
        node.update_game_grid((1,0,1,2))
        node.update_game_grid((1,0,2,1))
        node.player_to_move=-1
        node.update_game_grid((1,0,0,1))
        node.update_game_grid((1,0,1,1))
        node.update_game_grid((1,0,2,0))
        node.update_game_grid((1,0,2,2))
        node.player_to_move=1
        node.update_game_grid((1,1,0,0))
        node.update_game_grid((1,1,0,2))
        node.update_game_grid((1,1,1,0))
        node.update_game_grid((1,1,1,2))
        node.update_game_grid((1,1,2,1))
        node.player_to_move=-1
        node.update_game_grid((1,1,0,1))
        node.update_game_grid((1,1,1,1))
        node.update_game_grid((1,1,2,0))
        node.update_game_grid((1,1,2,2))
        node.player_to_move=1
        node.update_game_grid((1,2,0,0))
        node.update_game_grid((1,2,0,2))
        node.update_game_grid((1,2,1,0))
        node.update_game_grid((1,2,1,2))
        node.update_game_grid((1,2,2,1))
        node.player_to_move=-1
        node.update_game_grid((1,2,0,1))
        node.update_game_grid((1,2,1,1))
        node.update_game_grid((1,2,2,0))
        node.update_game_grid((1,2,2,2))
        node.player_to_move=1
        node.update_game_grid((2,1,0,0))
        node.update_game_grid((2,1,0,2))
        node.update_game_grid((2,1,1,0))
        node.update_game_grid((2,1,1,2))
        node.update_game_grid((2,1,2,1))
        node.player_to_move=-1
        node.update_game_grid((2,1,0,1))
        node.update_game_grid((2,1,1,1))
        node.update_game_grid((2,1,2,0))
        node.update_game_grid((2,1,2,2))
        node.player_to_move=1
        node.update_game_grid((0,0,0,0))
        node.update_game_grid((0,0,0,1))
        node.update_game_grid((0,0,0,2))
        node.update_game_grid((0,1,0,0))
        node.update_game_grid((0,1,0,1))
        node.update_game_grid((0,1,0,2))
        node.update_game_grid((0,2,0,0))
        node.update_game_grid((0,2,0,1))
        node.update_game_grid((2,2,0,0))
        node.update_game_grid((2,2,0,1))
        node.update_game_grid((2,2,1,0))
        node.update_game_grid((2,2,1,1))
        node.player_to_move=-1
        node.update_game_grid((2,2,2,0))
        node.update_game_grid((2,2,2,1))
        node.update_game_grid((2,2,0,2))
        node.update_game_grid((2,2,1,2))
        node.update_game_grid((0,1,1,0))
        node.update_game_grid((0,1,1,2))
        node.update_game_grid((0,1,2,1))
        node.update_game_grid((0,2,1,0))
        node.update_game_grid((0,2,2,1))
        node.player_to_move=1

        node.active_row=2
        node.active_col=0
    #30 free 3 step sacrifice to win, x only
    if setting ==2:
        correct_path=[(2,0,2,2),(2,2,2,2),(0,2,0,2)]
        node.player_to_move=1
        node.update_game_grid((1,0,0,0))
        node.update_game_grid((1,0,0,2))
        node.update_game_grid((1,0,1,0))
        node.update_game_grid((1,0,1,2))
        node.update_game_grid((1,0,2,1))
        node.player_to_move=-1
        node.update_game_grid((1,0,0,1))
        node.update_game_grid((1,0,1,1))
        node.update_game_grid((1,0,2,0))
        node.update_game_grid((1,0,2,2))
        node.player_to_move=1
        node.update_game_grid((1,1,0,0))
        node.update_game_grid((1,1,0,2))
        node.update_game_grid((1,1,1,0))
        node.update_game_grid((1,1,1,2))
        node.update_game_grid((1,1,2,1))
        node.player_to_move=-1
        node.update_game_grid((1,1,0,1))
        node.update_game_grid((1,1,1,1))
        node.update_game_grid((1,1,2,0))
        node.update_game_grid((1,1,2,2))


        node.player_to_move=1
        node.update_game_grid((0,0,0,0))
        node.update_game_grid((0,0,0,1))
        node.update_game_grid((0,0,0,2))
        node.update_game_grid((0,1,0,0))
        node.update_game_grid((0,1,0,1))
        node.update_game_grid((0,1,0,2))
        node.update_game_grid((0,2,0,0))
        node.update_game_grid((0,2,0,1))
        node.update_game_grid((2,2,0,0))
        node.update_game_grid((2,2,0,1))
        node.update_game_grid((2,2,1,0))
        node.update_game_grid((2,2,1,1))
        node.player_to_move=-1
        node.update_game_grid((2,2,2,0))
        node.update_game_grid((2,2,2,1))
        node.update_game_grid((2,2,0,2))
        node.update_game_grid((2,2,1,2))
        node.update_game_grid((0,0,1,0))
        node.update_game_grid((0,0,1,2))
        node.update_game_grid((0,0,2,1))
        node.update_game_grid((0,1,1,0))
        node.update_game_grid((0,1,1,2))
        node.update_game_grid((0,1,2,1))
        node.update_game_grid((0,2,1,0))
        node.update_game_grid((0,2,2,1))
        node.player_to_move=1

        node.active_row=2
        node.active_col=0
    #45 free 3 step sacrifice to win, x only
    if setting ==3:
        correct_path=[(2,0,2,2),(2,2,2,2),(0,2,0,2)]
        node.update_game_grid((0,0,0,0))
        node.update_game_grid((0,0,0,1))
        node.update_game_grid((0,0,0,2))
        node.update_game_grid((0,1,0,0))
        node.update_game_grid((0,1,0,1))
        node.update_game_grid((0,1,0,2))
        node.update_game_grid((0,2,0,0))
        node.update_game_grid((0,2,0,1))
        node.update_game_grid((2,2,0,0))
        node.update_game_grid((2,2,0,1))
        node.update_game_grid((2,2,1,0))
        node.update_game_grid((2,2,1,1))
        node.player_to_move=-1
        node.update_game_grid((2,2,2,0))
        node.update_game_grid((2,2,2,1))
        node.update_game_grid((2,2,0,2))
        node.update_game_grid((2,2,1,2))
        node.update_game_grid((0,1,1,0))
        node.update_game_grid((0,1,1,2))
        node.update_game_grid((0,1,2,1))
        node.update_game_grid((0,2,1,0))
        node.update_game_grid((0,2,2,1))
        node.player_to_move=1

        node.active_row=2
        node.active_col=0
    #15 free 3 step sacrifice to win, O can win
    if setting ==4:
        correct_path=[(2,0,2,2),(2,2,2,2),(0,2,0,2)]
        node.update_game_grid((2,1,0,0))
        node.update_game_grid((2,1,0,2))
        node.update_game_grid((2,1,1,1))

        node.player_to_move=-1
        node.update_game_grid((2,1,0,1))
        node.update_game_grid((2,1,1,0))
        node.update_game_grid((2,1,1,2))

        node.player_to_move=1
        node.update_game_grid((0,0,0,0))
        node.update_game_grid((0,0,0,1))
        node.update_game_grid((0,0,0,2))
        node.update_game_grid((0,1,0,0))
        node.update_game_grid((0,1,0,1))
        node.update_game_grid((0,1,0,2))
        node.update_game_grid((0,2,0,0))
        node.update_game_grid((0,2,0,1))
        node.update_game_grid((2,2,0,0))
        node.update_game_grid((2,2,0,1))
        node.update_game_grid((2,2,1,0))
        node.update_game_grid((2,2,1,1))

        node.player_to_move=-1
        node.update_game_grid((1,0,0,0))
        node.update_game_grid((1,0,0,1))
        node.update_game_grid((1,0,0,2))
        node.update_game_grid((1,1,0,0))
        node.update_game_grid((1,1,0,1))
        node.update_game_grid((1,1,0,2))
        node.update_game_grid((1,2,0,0))
        node.update_game_grid((1,2,0,1))
        node.update_game_grid((2,2,2,0))
        node.update_game_grid((2,2,2,1))
        node.update_game_grid((2,2,0,2))
        node.update_game_grid((2,2,1,2))
        node.update_game_grid((1,0,1,0))
        node.update_game_grid((1,0,2,1))
        node.update_game_grid((1,1,1,0))
        node.update_game_grid((1,1,2,1))
        node.update_game_grid((1,0,1,1))
        node.update_game_grid((1,0,1,2))
        node.update_game_grid((1,0,2,0))
        node.update_game_grid((1,0,2,2))
        node.update_game_grid((1,1,1,1))
        node.update_game_grid((1,1,1,2))
        node.update_game_grid((1,1,2,0))
        node.update_game_grid((1,1,2,2))
        node.update_game_grid((0,0,1,0))
        node.update_game_grid((0,0,1,1))
        node.update_game_grid((0,0,1,2))
        node.update_game_grid((0,1,1,0))
        node.update_game_grid((0,1,1,1))
        node.update_game_grid((0,1,1,2))
        node.update_game_grid((0,1,2,0))
        node.update_game_grid((0,1,2,1))
        node.update_game_grid((0,1,2,2))
        node.active_row=2
        node. active_col=0
        node.player_to_move=1
    #30 free 3 step sacrifice to win, O can win
    if setting ==5:
        correct_path=[(2,0,2,2),(2,2,2,2),(0,2,0,2)]
        node.update_game_grid((2,1,0,0))
        node.update_game_grid((2,1,0,2))
        node.update_game_grid((2,1,1,0))
        node.update_game_grid((2,1,1,2))
        node.update_game_grid((2,1,2,1))




        node.player_to_move=-1
        node.update_game_grid((1,0,2,2))
        node.update_game_grid((1,0,1,1))
        node.update_game_grid((1,0,1,2))
        node.update_game_grid((1,0,2,0))
        node.update_game_grid((1,0,2,1))
        node.update_game_grid((1,0,1,0))
        node.update_game_grid((2,1,0,1))
        node.update_game_grid((2,1,1,1))
        node.update_game_grid((2,1,2,0))
        node.update_game_grid((2,1,2,2))
        node.player_to_move=1
        node.update_game_grid((0,0,0,0))
        node.update_game_grid((0,0,0,1))
        node.update_game_grid((0,0,0,2))
        node.update_game_grid((0,1,0,0))
        node.update_game_grid((0,1,0,1))
        node.update_game_grid((0,1,0,2))
        node.update_game_grid((0,2,0,0))
        node.update_game_grid((0,2,0,1))
        node.update_game_grid((2,2,0,0))
        node.update_game_grid((2,2,0,1))
        node.update_game_grid((2,2,1,0))
        node.update_game_grid((2,2,1,1))
        node.player_to_move=-1
        node.update_game_grid((1,0,0,0))
        node.update_game_grid((1,0,0,1))
        node.update_game_grid((1,0,0,2))
        node.update_game_grid((1,1,0,0))
        node.update_game_grid((1,1,0,1))
        node.update_game_grid((1,1,0,2))
        node.update_game_grid((1,2,0,0))
        node.update_game_grid((1,2,0,1))
        node.update_game_grid((2,2,2,0))
        node.update_game_grid((2,2,2,1))
        node.update_game_grid((2,2,0,2))
        node.update_game_grid((2,2,1,2))
        node.active_row=2
        node. active_col=0
        node.player_to_move=1
    #45 free 3 step sacrifice to win, O can win
    if setting ==6:
        correct_path=[(2,0,2,2),(2,2,2,2),(0,2,0,2)]
        node.update_game_grid((0,0,0,0))
        node.update_game_grid((0,0,0,1))
        node.update_game_grid((0,0,0,2))
        node.update_game_grid((0,1,0,0))
        node.update_game_grid((0,1,0,1))
        node.update_game_grid((0,1,0,2))
        node.update_game_grid((0,2,0,0))
        node.update_game_grid((0,2,0,1))
        node.update_game_grid((2,2,0,0))
        node.update_game_grid((2,2,0,1))
        node.update_game_grid((2,2,1,0))
        node.update_game_grid((2,2,1,1))
        node.player_to_move=-1
        node.update_game_grid((1,0,0,0))
        node.update_game_grid((1,0,0,1))
        node.update_game_grid((1,0,0,2))
        node.update_game_grid((1,1,0,0))
        node.update_game_grid((1,1,0,1))
        node.update_game_grid((1,1,0,2))
        node.update_game_grid((1,2,0,0))
        node.update_game_grid((1,2,0,1))
        node.update_game_grid((2,2,2,0))
        node.update_game_grid((2,2,2,1))
        node.update_game_grid((2,2,0,2))
        node.update_game_grid((2,2,1,2))
        node.active_row=2
        node. active_col=0
        node.player_to_move=1

    #45 free 3 step sacrifice to control centre, O gets bottom right
    if setting ==7:
        correct_path=[(2,0,2,2),(2,2,1,1),(1,1,2,0)]
        node.update_game_grid((2,1,0,0))
        node.update_game_grid((2,1,0,2))
        node.update_game_grid((2,1,1,0))
        node.update_game_grid((2,1,1,2))
        node.update_game_grid((2,1,2,1))
        node.player_to_move=-1
        node.update_game_grid((2,1,0,1))
        node.update_game_grid((2,1,1,1))
        node.update_game_grid((2,1,2,0))
        node.update_game_grid((2,1,2,2))
        node.player_to_move=1
        node.update_game_grid((1,1,0,0))
        node.update_game_grid((1,1,1,0))
        node.update_game_grid((2,2,0,0))
        node.update_game_grid((2,2,2,2))
        node.player_to_move=-1
        node.update_game_grid((1,1,1,1))
        node.update_game_grid((1,1,1,2))
        node.update_game_grid((1,1,2,1))
        node.update_game_grid((1,1,2,2))
        node.update_game_grid((2,2,0,1))
        node.update_game_grid((2,2,0,2))
        node.update_game_grid((2,2,1,0))
        node.update_game_grid((2,2,1,2))
        node.update_game_grid((2,2,2,0))
        node.update_game_grid((2,2,2,1))
        node.active_row=2
        node. active_col=0
        node.player_to_move=1
    #15 free, 5 step sacrifice to win, O can win
    if setting ==8:
        correct_path=[(2,0,2,2),(2,2,1,1),(1,1,2,1),(2,1,0,2),(0,2,0,2)]
        node.update_game_grid((0,0,0,0))
        node.update_game_grid((0,0,0,1))
        node.update_game_grid((0,0,0,2))
        node.update_game_grid((0,1,0,0))
        node.update_game_grid((0,1,0,1))
        node.update_game_grid((0,1,0,2))
        node.update_game_grid((0,2,0,0))
        node.update_game_grid((0,2,0,1))
        node.update_game_grid((2,1,0,0))
        node.update_game_grid((2,1,1,1))
        node.update_game_grid((2,1,1,2))
        node.update_game_grid((2,1,2,1))
        node.update_game_grid((2,2,0,1))
        node.update_game_grid((2,2,1,0))
        node.update_game_grid((2,2,2,0))
        node.update_game_grid((2,2,2,2))
        node.update_game_grid((0,0,1,0))
        node.update_game_grid((0,0,1,1))
        node.update_game_grid((0,0,1,2))
        node.update_game_grid((0,0,2,0))
        node.update_game_grid((0,0,2,1))
        node.update_game_grid((0,0,2,2))
        node.update_game_grid((0,1,1,0))
        node.update_game_grid((0,1,1,1))
        node.update_game_grid((0,1,1,2))
        node.update_game_grid((0,1,2,0))
        node.update_game_grid((0,1,2,1))
        node.update_game_grid((0,1,2,2))
        node.update_game_grid((0,2,1,2))
        node.update_game_grid((0,2,2,2))
        node.player_to_move=-1
        node.update_game_grid((0,2,1,0))
        node.update_game_grid((0,2,1,1))

        node.update_game_grid((0,2,2,0))
        node.update_game_grid((0,2,2,1))

        node.update_game_grid((1,0,1,0))
        node.update_game_grid((1,0,1,1))
        node.update_game_grid((1,0,1,2))
        node.update_game_grid((1,0,0,0))
        node.update_game_grid((1,0,0,1))
        node.update_game_grid((1,0,0,2))
        node.update_game_grid((1,1,0,0))
        node.update_game_grid((1,1,0,1))
        node.update_game_grid((1,1,0,2))
        node.update_game_grid((1,2,0,0))
        node.update_game_grid((1,2,0,1))
        node.update_game_grid((2,2,0,0))
        node.update_game_grid((2,2,0,2))

        node.update_game_grid((2,2,1,2))
        node.update_game_grid((2,2,2,1))
        node.update_game_grid((2,1,0,1))
        node.update_game_grid((2,1,1,0))
        node.update_game_grid((2,1,2,0))
        node.update_game_grid((2,1,2,2))
        node.update_game_grid((2,0,2,1))
        node.player_to_move=1
        node.active_row=2
        node.active_col=0
    #30 free, 5 step sacrifice to win, O can win
    if setting ==9:
        correct_path=[(2,0,2,2),(2,2,1,1),(1,1,2,1),(2,1,0,2),(0,2,0,2)]
        node.update_game_grid((0,0,0,0))
        node.update_game_grid((0,0,0,1))
        node.update_game_grid((0,0,0,2))
        node.update_game_grid((0,1,0,0))
        node.update_game_grid((0,1,0,1))
        node.update_game_grid((0,1,0,2))
        node.update_game_grid((0,2,0,0))
        node.update_game_grid((0,2,0,1))
        node.update_game_grid((2,1,0,0))
        node.update_game_grid((2,1,1,1))
        node.update_game_grid((2,1,1,2))
        node.update_game_grid((2,1,2,1))
        node.update_game_grid((2,2,0,1))
        node.update_game_grid((2,2,1,0))
        node.update_game_grid((2,2,2,0))
        node.update_game_grid((2,2,2,2))
        node.update_game_grid((0,0,1,0))
        node.update_game_grid((0,0,1,1))
        node.update_game_grid((0,0,1,2))
        node.update_game_grid((0,0,2,0))
        node.update_game_grid((0,0,2,1))
        node.update_game_grid((0,0,2,2))
        node.player_to_move=-1

        node.update_game_grid((1,0,0,0))
        node.update_game_grid((1,0,0,1))
        node.update_game_grid((1,0,0,2))
        node.update_game_grid((1,1,0,0))
        node.update_game_grid((1,1,0,1))
        node.update_game_grid((1,1,0,2))
        node.update_game_grid((1,2,0,0))
        node.update_game_grid((1,2,0,1))
        node.update_game_grid((2,2,0,0))
        node.update_game_grid((2,2,0,2))

        node.update_game_grid((2,2,1,2))
        node.update_game_grid((2,2,2,1))
        node.update_game_grid((2,1,0,1))
        node.update_game_grid((2,1,1,0))
        node.update_game_grid((2,1,2,0))
        node.update_game_grid((2,1,2,2))
        node.update_game_grid((2,0,2,1))
        node.player_to_move=1
        node.active_row=2
        node.active_col=0
    #36 free, 5 step sacrifice to win, O can win
    if setting ==10:
        correct_path=[(2,0,2,2),(2,2,1,1),(1,1,2,1),(2,1,0,2),(0,2,0,2)]
        node.update_game_grid((0,0,0,0))
        node.update_game_grid((0,0,0,1))
        node.update_game_grid((0,0,0,2))
        node.update_game_grid((0,1,0,0))
        node.update_game_grid((0,1,0,1))
        node.update_game_grid((0,1,0,2))
        node.update_game_grid((0,2,0,0))
        node.update_game_grid((0,2,0,1))
        node.update_game_grid((2,1,0,0))
        node.update_game_grid((2,1,1,1))
        node.update_game_grid((2,1,1,2))
        node.update_game_grid((2,1,2,1))
        node.update_game_grid((2,2,0,1))
        node.update_game_grid((2,2,1,0))
        node.update_game_grid((2,2,2,0))
        node.update_game_grid((2,2,2,2))
        node.player_to_move=-1
        node.update_game_grid((1,0,0,0))
        node.update_game_grid((1,0,0,1))
        node.update_game_grid((1,0,0,2))
        node.update_game_grid((1,1,0,0))
        node.update_game_grid((1,1,0,1))
        node.update_game_grid((1,1,0,2))
        node.update_game_grid((1,2,0,0))
        node.update_game_grid((1,2,0,1))
        node.update_game_grid((2,2,0,0))
        node.update_game_grid((2,2,0,2))

        node.update_game_grid((2,2,1,2))
        node.update_game_grid((2,2,2,1))
        node.update_game_grid((2,1,0,1))
        node.update_game_grid((2,1,1,0))
        node.update_game_grid((2,1,2,0))
        node.update_game_grid((2,1,2,2))
        node.update_game_grid((2,0,2,1))
        node.player_to_move=1
        node.active_row=2
        node.active_col=0
    #45 free 5 step sacrifice to control centre, O gets bottom right
    if setting ==12:
        correct_path=[(2,0,2,1),(2,1,1,0),(1,0,1,1),(1,1,0,2),(0,2,0,2)]
        node.update_game_grid((0,0,0,0))
        node.update_game_grid((0,0,0,1))
        node.update_game_grid((0,0,0,2))
        node.update_game_grid((0,1,0,0))
        node.update_game_grid((0,1,0,1))
        node.update_game_grid((0,1,0,2))
        node.update_game_grid((0,2,0,0))
        node.update_game_grid((0,2,0,1))
        node.update_game_grid((1,1,1,0))
        node.update_game_grid((1,1,1,1))
        node.update_game_grid((1,1,2,0))
        node.update_game_grid((1,1,2,1))

        node.update_game_grid((2,1,0,2))
        node.update_game_grid((2,1,1,1))
        node.update_game_grid((2,1,2,1))
        node.update_game_grid((2,0,1,1))


        node.player_to_move=-1
        node.update_game_grid((2,1,0,0))
        node.update_game_grid((0,2,1,2))
        node.update_game_grid((0,2,2,2))
        node.update_game_grid((1,2,0,2))
        node.update_game_grid((1,2,1,2))
        node.update_game_grid((1,2,2,2))
        node.update_game_grid((2,2,0,2))
        node.update_game_grid((2,2,1,2))
        node.update_game_grid((2,2,2,2))
        node.update_game_grid((1,1,0,0))
        node.update_game_grid((1,1,0,1))
        node.update_game_grid((1,1,1,2))
        node.update_game_grid((1,1,2,2))
        node.update_game_grid((2,1,0,1))
        node.update_game_grid((2,1,1,2))
        node.update_game_grid((2,1,2,0))
        node.update_game_grid((2,1,2,2))


        node.active_row=2
        node. active_col=0
        node.player_to_move=1
    #fixed 12
    if setting ==19:
        correct_path=[(2,0,2,1),(2,1,1,0),(1,0,1,1),(1,1,0,2),(0,2,0,2)]
        node.update_game_grid((0,0,0,0))
        node.update_game_grid((0,0,0,1))
        node.update_game_grid((0,0,0,2))
        node.update_game_grid((0,1,0,0))
        node.update_game_grid((0,1,0,1))
        node.update_game_grid((0,1,0,2))
        node.update_game_grid((0,2,0,0))
        node.update_game_grid((0,2,0,1))
        node.update_game_grid((1,1,1,0))
        node.update_game_grid((1,1,1,1))
        node.update_game_grid((1,1,2,0))
        node.update_game_grid((1,1,2,1))

        node.update_game_grid((2,1,0,2))
        node.update_game_grid((2,1,1,1))
        node.update_game_grid((2,1,2,1))
        node.update_game_grid((2,0,1,1))


        node.player_to_move=-1
        node.update_game_grid((2,1,0,0))
        node.update_game_grid((0,2,1,2))
        node.update_game_grid((0,2,2,2))
        node.update_game_grid((1,2,0,2))
        node.update_game_grid((1,2,1,2))
        node.update_game_grid((1,2,2,2))
        node.update_game_grid((2,2,0,2))
        node.update_game_grid((2,2,1,2))
        node.update_game_grid((2,2,2,2))
        node.update_game_grid((1,1,0,0))
        node.update_game_grid((1,1,0,1))
        node.update_game_grid((1,1,1,2))
        node.update_game_grid((1,1,2,2))
        node.update_game_grid((2,1,0,1))
        node.update_game_grid((2,1,1,2))
        node.update_game_grid((2,1,2,0))
        node.update_game_grid((2,1,2,2))


        node.active_row=2
        node. active_col=0
        node.player_to_move=1
    if setting ==11:
        correct_path=[(2,0,2,1),(2,1,0,0),(0,0,0,1),(0,1,1,1),(1,1,0,1)]
        node.update_game_grid((0,1,0,0))
        node.update_game_grid((0,1,1,2))
        node.update_game_grid((0,1,2,1))
        node.update_game_grid((1,1,0,0))
        node.update_game_grid((1,1,0,2))
        node.update_game_grid((2,0,0,1))
        node.update_game_grid((2,1,1,1))
        node.update_game_grid((2,1,1,2))
        node.update_game_grid((2,1,2,1))
        node.update_game_grid((2,1,2,2))

        node.player_to_move=-1
        node.update_game_grid((0,1,0,1))
        node.update_game_grid((0,1,0,2))
        node.update_game_grid((0,1,1,0))
        node.update_game_grid((0,1,2,0))
        node.update_game_grid((0,1,2,2))
        node.update_game_grid((1,1,1,1))
        node.update_game_grid((1,1,1,2))
        node.update_game_grid((1,1,2,1))
        node.update_game_grid((1,1,2,2))
        node.update_game_grid((2,1,0,1))
        node.update_game_grid((2,1,0,2))
        node.update_game_grid((2,1,1,0))
        node.update_game_grid((2,1,2,0))
        node.player_to_move=1
        node.active_row=2
        node.active_col=0

    #15 free, 5 step sacrifice to win, O can win
    if setting ==13:
        correct_path=[(2,0,2,2),(2,2,1,1),(1,1,2,1),(2,1,0,2),(0,2,0,2)]
        node.update_game_grid((0,0,0,0))
        node.update_game_grid((0,0,0,1))
        node.update_game_grid((0,0,0,2))
        node.update_game_grid((0,1,0,0))
        node.update_game_grid((0,1,0,1))
        node.update_game_grid((0,1,0,2))
        node.update_game_grid((0,2,0,0))
        node.update_game_grid((0,2,0,1))
        node.update_game_grid((2,1,0,0))
        node.update_game_grid((2,1,1,1))

        node.update_game_grid((2,1,2,1))
        node.update_game_grid((2,2,0,1))

        node.update_game_grid((2,2,2,0))
        node.update_game_grid((2,2,2,2))
        node.update_game_grid((0,0,1,0))
        node.update_game_grid((0,0,1,1))
        node.update_game_grid((0,0,1,2))
        node.update_game_grid((0,0,2,0))
        node.update_game_grid((0,0,2,1))
        node.update_game_grid((0,0,2,2))
        node.update_game_grid((0,1,1,0))
        node.update_game_grid((0,1,1,1))
        node.update_game_grid((0,1,1,2))
        node.update_game_grid((0,1,2,0))
        node.update_game_grid((0,1,2,1))
        node.update_game_grid((0,1,2,2))
        node.update_game_grid((0,2,1,2))
        node.update_game_grid((0,2,2,2))
        node.player_to_move=-1
        node.update_game_grid((2,1,1,2))
        node.update_game_grid((0,2,1,0))
        node.update_game_grid((0,2,1,1))
        node.update_game_grid((2,2,1,0))
        node.update_game_grid((0,2,2,0))
        node.update_game_grid((0,2,2,1))

        node.update_game_grid((1,0,1,0))
        node.update_game_grid((1,0,1,1))
        node.update_game_grid((1,0,1,2))
        node.update_game_grid((1,0,0,0))
        node.update_game_grid((1,0,0,1))
        node.update_game_grid((1,0,0,2))
        node.update_game_grid((1,1,0,0))
        node.update_game_grid((1,1,0,1))
        node.update_game_grid((1,1,0,2))
        node.update_game_grid((1,2,0,0))
        node.update_game_grid((1,2,0,1))
        node.update_game_grid((2,2,0,0))
        node.update_game_grid((2,2,0,2))

        node.update_game_grid((2,2,1,2))
        node.update_game_grid((2,2,2,1))
        node.update_game_grid((2,1,0,1))
        node.update_game_grid((2,1,1,0))
        node.update_game_grid((2,1,2,0))
        node.update_game_grid((2,1,2,2))
        node.update_game_grid((2,0,2,1))
        node.player_to_move=1
        node.active_row=2
        node.active_col=0
    #30 free, 5 step sacrifice to win, O can win
    if setting ==14:
        correct_path=[(2,0,2,2),(2,2,1,1),(1,1,2,1),(2,1,0,2),(0,2,0,2)]
        node.update_game_grid((0,0,0,0))
        node.update_game_grid((0,0,0,1))
        node.update_game_grid((0,0,0,2))
        node.update_game_grid((0,1,0,0))
        node.update_game_grid((0,1,0,1))
        node.update_game_grid((0,1,0,2))
        node.update_game_grid((0,2,0,0))
        node.update_game_grid((0,2,0,1))
        node.update_game_grid((2,1,0,0))
        node.update_game_grid((2,1,1,1))

        node.update_game_grid((2,1,2,1))
        node.update_game_grid((2,2,0,1))

        node.update_game_grid((2,2,2,0))
        node.update_game_grid((2,2,2,2))
        node.update_game_grid((0,0,1,0))
        node.update_game_grid((0,0,1,1))
        node.update_game_grid((0,0,1,2))
        node.update_game_grid((0,0,2,0))
        node.update_game_grid((0,0,2,1))
        node.update_game_grid((0,0,2,2))
        node.player_to_move=-1
        node.update_game_grid((2,1,1,2))
        node.update_game_grid((2,2,1,0))
        node.update_game_grid((1,0,0,0))
        node.update_game_grid((1,0,0,1))
        node.update_game_grid((1,0,0,2))
        node.update_game_grid((1,1,0,0))
        node.update_game_grid((1,1,0,1))
        node.update_game_grid((1,1,0,2))
        node.update_game_grid((1,2,0,0))
        node.update_game_grid((1,2,0,1))
        node.update_game_grid((2,2,0,0))
        node.update_game_grid((2,2,0,2))

        node.update_game_grid((2,2,1,2))
        node.update_game_grid((2,2,2,1))
        node.update_game_grid((2,1,0,1))
        node.update_game_grid((2,1,1,0))
        node.update_game_grid((2,1,2,0))
        node.update_game_grid((2,1,2,2))
        node.update_game_grid((2,0,2,1))
        node.player_to_move=1
        node.active_row=2
        node.active_col=0
    #36 free, 5 step sacrifice to win, O can win
    if setting ==15:
        correct_path=[(2,0,2,2),(2,2,1,1),(1,1,2,1),(2,1,0,2),(0,2,0,2)]
        node.update_game_grid((0,0,0,0))
        node.update_game_grid((0,0,0,1))
        node.update_game_grid((0,0,0,2))
        node.update_game_grid((0,1,0,0))
        node.update_game_grid((0,1,0,1))
        node.update_game_grid((0,1,0,2))
        node.update_game_grid((0,2,0,0))
        node.update_game_grid((0,2,0,1))
        node.update_game_grid((2,1,0,0))
        node.update_game_grid((2,1,1,1))

        node.update_game_grid((2,1,2,1))
        node.update_game_grid((2,2,0,1))

        node.update_game_grid((2,2,2,0))
        node.update_game_grid((2,2,2,2))
        node.player_to_move=-1
        node.update_game_grid((2,1,1,2))
        node.update_game_grid((2,2,1,0))
        node.update_game_grid((1,0,0,0))
        node.update_game_grid((1,0,0,1))
        node.update_game_grid((1,0,0,2))
        node.update_game_grid((1,1,0,0))
        node.update_game_grid((1,1,0,1))
        node.update_game_grid((1,1,0,2))
        node.update_game_grid((1,2,0,0))
        node.update_game_grid((1,2,0,1))
        node.update_game_grid((2,2,0,0))
        node.update_game_grid((2,2,0,2))

        node.update_game_grid((2,2,1,2))
        node.update_game_grid((2,2,2,1))
        node.update_game_grid((2,1,0,1))
        node.update_game_grid((2,1,1,0))
        node.update_game_grid((2,1,2,0))
        node.update_game_grid((2,1,2,2))
        node.update_game_grid((2,0,2,1))
        node.player_to_move=1
        node.active_row=2
        node.active_col=0
    if setting ==16: #bad
        correct_path=[(2,0,2,1),(2,1,0,0),(0,0,1,0),(1,0,1,2),(1,2,1,1),(1,1,0,2),(0,2,0,2)]
        node.update_game_grid((0,0,0,0))
        node.update_game_grid((0,0,1,1))
        node.update_game_grid((0,0,0,1))
        node.update_game_grid((0,0,0,2))
        node.update_game_grid((0,1,0,0))
        node.update_game_grid((0,1,0,1))
        node.update_game_grid((0,1,0,2))
        node.update_game_grid((0,2,0,0))
        node.update_game_grid((0,2,0,1))
        node.update_game_grid((1,1,1,0))
        node.update_game_grid((1,1,1,1))
        node.update_game_grid((1,1,2,0))
        node.update_game_grid((1,1,2,1))

        node.update_game_grid((2,1,2,2))
        node.update_game_grid((2,1,1,1))
        node.update_game_grid((2,1,2,1))
        node.update_game_grid((2,1,1,2))
        node.update_game_grid((2,0,1,1))
        node.update_game_grid((2,0,1,0))
        node.update_game_grid((1,0,0,1))
        node.update_game_grid((1,0,0,2))
        node.update_game_grid((1,0,2,0))
        node.update_game_grid((1,0,2,2))


        node.player_to_move=-1
        node.update_game_grid((2,1,1,0))
        node.update_game_grid((2,1,2,0))
        node.update_game_grid((2,1,0,1))
        node.update_game_grid((2,1,0,2))
        node.update_game_grid((0,2,1,2))
        node.update_game_grid((0,2,2,2))
        node.update_game_grid((1,2,0,2))
        node.update_game_grid((1,2,1,2))
        node.update_game_grid((1,2,2,2))
        node.update_game_grid((2,2,0,2))
        node.update_game_grid((2,2,1,2))
        node.update_game_grid((2,2,2,2))
        node.update_game_grid((1,1,0,0))
        node.update_game_grid((1,1,0,1))
        node.update_game_grid((1,1,1,2))
        node.update_game_grid((1,1,2,2))
        node.update_game_grid((1,0,0,0))
        node.update_game_grid((1,0,1,1))
        node.update_game_grid((1,0,1,0))
        node.update_game_grid((1,0,2,1))


        node.active_row=2
        node. active_col=0
        node.player_to_move=1
    if setting ==17:
        correct_path=[(2,0,2,1),(2,1,0,0),(0,0,1,0),(1,0,1,2),(1,2,1,1),(1,1,0,2),(0,2,0,2)]

        node.update_game_grid((0,0,0,0))
        node.update_game_grid((0,0,1,1))
        node.update_game_grid((0,0,0,1))
        node.update_game_grid((0,0,0,2))
        node.update_game_grid((0,1,0,0))
        node.update_game_grid((0,1,0,1))
        node.update_game_grid((0,1,0,2))
        node.update_game_grid((0,2,0,0))
        node.update_game_grid((0,2,0,1))
        node.update_game_grid((1,1,0,0))
        node.update_game_grid((1,1,1,2))
        node.update_game_grid((1,1,1,0))
        node.update_game_grid((1,1,2,1))
        node.update_game_grid((2,1,2,2))
        node.update_game_grid((2,1,1,1))
        node.update_game_grid((2,1,2,1))
        node.update_game_grid((2,1,1,2))

        node.update_game_grid((1,0,0,1))
        node.update_game_grid((1,0,1,1))
        node.update_game_grid((1,0,2,0))
        node.update_game_grid((1,0,2,2))


        node.player_to_move=-1
        node.update_game_grid((2,1,1,0))
        node.update_game_grid((2,1,2,0))
        node.update_game_grid((2,1,0,1))
        node.update_game_grid((2,1,0,2))
        node.update_game_grid((0,2,1,2))
        node.update_game_grid((0,2,2,2))
        node.update_game_grid((1,2,0,2))
        node.update_game_grid((1,2,1,2))
        node.update_game_grid((1,2,2,2))
        node.update_game_grid((2,2,0,2))
        node.update_game_grid((2,2,1,2))
        node.update_game_grid((2,2,2,2))
        node.update_game_grid((1,1,0,1))
        node.update_game_grid((1,1,1,1))
        node.update_game_grid((1,1,2,0))
        node.update_game_grid((1,1,2,2))
        node.update_game_grid((1,0,0,0))
        node.update_game_grid((1,0,0,2))
        node.update_game_grid((1,0,1,0))
        node.update_game_grid((1,0,2,1))
        node.update_game_grid((2,0,1,1))
        node.update_game_grid((2,0,1,0))

        node.active_row=2
        node. active_col=0
        node.player_to_move=1
    if setting ==18:
        correct_path=[(2,0,1,1),(1,1,2,2),(2,2,0,1),(0,1,2,1),(2,1,0,0),(0,0,0,2),(0,2,0,2)]
        node.update_game_grid((0,0,0,0))
        node.update_game_grid((0,0,0,1))
        node.update_game_grid((0,0,1,0))
        node.update_game_grid((0,0,1,1))
        node.update_game_grid((0,0,1,2))
        node.update_game_grid((0,0,2,0))
        node.update_game_grid((0,0,2,1))
        node.update_game_grid((0,0,2,2))
        node.update_game_grid((0,1,0,0))
        node.update_game_grid((0,1,0,1))
        node.update_game_grid((0,1,0,2))
        node.update_game_grid((0,1,1,0))
        node.update_game_grid((0,1,1,1))
        node.update_game_grid((0,1,1,2))
        node.update_game_grid((0,1,2,0))
        node.update_game_grid((0,1,2,2))
        node.update_game_grid((0,2,0,0))
        node.update_game_grid((0,2,0,1))

        node.update_game_grid((1,1,0,1))
        node.update_game_grid((1,1,1,0))
        node.update_game_grid((1,1,2,0))
        node.player_to_move=-1
        node.update_game_grid((2,2,0,0))
        node.update_game_grid((2,2,0,2))
        node.update_game_grid((2,2,1,2))
        node.update_game_grid((2,2,2,2))

        node.update_game_grid((2,0,0,0))
        node.update_game_grid((2,0,0,1))

        node.update_game_grid((0,2,1,2))
        node.update_game_grid((0,2,2,2))

        node.update_game_grid((1,2,0,2))
        node.update_game_grid((1,2,1,2))
        node.update_game_grid((1,2,2,2))

        node.update_game_grid((1,1,0,0))
        node.update_game_grid((1,1,0,2))
        node.update_game_grid((1,1,1,1))
        node.update_game_grid((1,1,1,2))
        node.update_game_grid((1,1,2,1))

        node.active_row=2
        node. active_col=0
        node.player_to_move=1

    if setting ==20:
        correct_path=[(2,0,2,1),(2,1,0,0),(0,0,1,0),(1,0,1,2),(1,2,1,1),(1,1,0,2),(0,2,0,2)]

        node.update_game_grid((0,0,0,0))
        node.update_game_grid((0,0,1,1))
        node.update_game_grid((0,0,0,1))
        node.update_game_grid((0,0,0,2))
        node.update_game_grid((0,1,0,0))
        node.update_game_grid((0,1,0,1))
        node.update_game_grid((0,1,0,2))
        node.update_game_grid((0,2,0,0))
        node.update_game_grid((0,2,0,1))
        node.update_game_grid((1,1,0,0))
        node.update_game_grid((1,1,1,2))
        node.update_game_grid((1,1,1,0))
        node.update_game_grid((1,1,2,1))
        node.update_game_grid((2,1,2,2))
        node.update_game_grid((2,1,1,1))
        node.update_game_grid((2,1,2,1))
        node.update_game_grid((2,1,1,2))

        node.update_game_grid((1,0,0,1))
        node.update_game_grid((1,0,1,1))
        node.update_game_grid((1,0,2,0))
        node.update_game_grid((1,0,2,2))
        node.update_game_grid((2,0,1,0))


        node.player_to_move=-1
        node.update_game_grid((2,1,1,0))
        node.update_game_grid((2,1,2,0))
        node.update_game_grid((2,1,0,1))
        node.update_game_grid((2,1,0,2))
        node.update_game_grid((0,2,1,2))
        node.update_game_grid((0,2,2,2))
        node.update_game_grid((1,2,0,2))
        node.update_game_grid((1,2,1,2))
        node.update_game_grid((1,2,2,2))
        node.update_game_grid((2,2,0,2))
        node.update_game_grid((2,2,1,2))
        node.update_game_grid((2,2,2,2))
        node.update_game_grid((1,1,0,1))
        node.update_game_grid((1,1,1,1))
        node.update_game_grid((1,1,2,0))
        node.update_game_grid((1,1,2,2))
        node.update_game_grid((1,0,0,0))
        node.update_game_grid((1,0,0,2))
        node.update_game_grid((1,0,1,0))
        node.update_game_grid((1,0,2,1))
        node.update_game_grid((2,0,1,1))
        

        node.active_row=2
        node. active_col=0
        node.player_to_move=1


    return node

def check_decisive_whole_grid(current_node):
    move=None
    game_grid=current_node.game_grid
    winning_number=2*current_node.player_to_move
    active_row=current_node.active_row
    active_col=current_node.active_col
    big_rows=[]
    big_cols=[]
    big_diags=[]
    if active_row==-1:

        for i in(0,1,2):
            #checking the big row scores
            if game_grid[3,i,0,0]==winning_number:
                big_rows.append(i)
            #checking the big col scores
            if game_grid[4,i,0,0]==winning_number:
                big_cols.append(i)
        #checking the big diag scores
        if game_grid[5,0,5,0]==winning_number:
            big_diags.append(1)
        if game_grid[5,1,0,0]==winning_number:
            big_diags.append(2)
        # go look through all the rows and cols with 2 in a row and see if those boxes are winnable
        if big_rows:

            for i in range (0,big_rows.__len__()):
                move= check_decisive_small(current_node,1,big_rows[i])

                return move
        if big_cols:

            for i in range (0,big_cols.__len__()):
                move = check_decisive_small(current_node,2,big_cols[i])

                return move
        if big_diags:

            for i in range (0,big_diags.__len__()):
                move = check_decisive_small(current_node,3,big_diags[i])

                return move
    #if we must play on a particular board, simply check if that row, col and possible
    # diagonals are winnable and if so, see if there is a winning move this board
    else:
        move = check_decisive_targeted(current_node)

        return move
    return None

#checks for a decisive move when we have a specific box to move in
def check_decisive_targeted(current_node):
    move= None
    row = current_node.active_row
    col=current_node.active_col
    
    diag1=False
    diag2=False
    if row==col:
        diag1=True
    if row+col==2:
        diag2=True
    game_grid=current_node.game_grid
    winning_number=current_node.player_to_move*2
    #if the box has already been won, return None
    if game_grid[row,col,5,2]==winning_number or game_grid[row,col,5,2]==winning_number/2:
        
        return None
    #if the appropriate big row or column can be won, then see if the box can be won
    if game_grid[3,row,0,0]==winning_number or game_grid[4,col,0,0]==winning_number or (diag1 and game_grid[5,0,5,0]==winning_number) or (diag2 and game_grid[5,1,0,0]==winning_number):
            #row
         for i in (0,1,2):
            if game_grid[row,col,3,i]==winning_number:
                for j in(0,1,2):
                    if game_grid[row,col,i,j]==0:
                            
                            return (row,col,i,j)
            #column
         for i in (0,1,2):
                if game_grid[row,col,4,i]==winning_number:
                    for j in(0,1,2):
                        if game_grid[row,col,j,i]==0:
                                
                                return (row,col,j,i)
            #and diagonal scores for ways to win in that box
         if game_grid[row,col,5,1]==winning_number:
                for i in(0,1,2):
                    if game_grid[row,col,i,i]==0:
                            
                            return (row,col,i,i)
         if game_grid[row,col,5,2]==winning_number:
                for i in(0,1,2):
                    if game_grid[row,col,2-i,i]==0:
                            
                            return (row,col,2-i,i)
    return None


def check_decisive_small(current_node,type,index):

    game_grid=current_node.game_grid
    winning_number=2*current_node.player_to_move
    target_row=None
    target_col=None
    target_index=None
    #if there is a win possible on the big board via a row
    if type==1:
        for i in (0,1,2):
            #find the box which has not been won

            if game_grid[index,i,5,2]==0:
                target_col=i

        #within that box, check the row
        for i in (0,1,2):
            if game_grid[index,target_col,3,i]==winning_number:
                for j in(0,1,2):
                    if game_grid[index,target_col,i,j]==0:

                            return (index,target_col,i,j)
        #column
        for i in (0,1,2):
            if game_grid[index,target_col,4,i]==winning_number:
                for j in(0,1,2):
                    if game_grid[index,target_col,j,i]==0:

                            return (index,target_col,j,i)
        #and diagonal scores for ways to win in that box
        if game_grid[index,target_col,5,1]==winning_number:
            for i in(0,1,2):
                if game_grid[index,target_col,i,i]==0:

                        return (index,target_col,i,i)
        if game_grid[index,target_col,5,2]==winning_number:
            for i in(0,1,2):
                if game_grid[index,target_col,2-j,j]==0:

                        return (index,target_col,2-i,i)


    if type==2:
        for i in(0,1,2):

            if game_grid[i,index,5,2]==0:
                target_row=i


        for i in (0,1,2):
            if game_grid[target_row,index,3,i]==winning_number:
                for j in(0,1,2):
                    if game_grid[target_row,index,i,j]==0:

                            return (target_row,index,i,j)
        for i in (0,1,2):
            if game_grid[target_row,index,4,i]==winning_number:
                for j in(0,1,2):
                    if game_grid[target_row,index,j,i]==0:

                            return (target_row,index,j,i)
        if game_grid[target_row,index,5,1]==winning_number:
            for i in(0,1,2):
                if game_grid[target_row,index,i,i]==0:

                        return (target_row,index,i,i)
        if game_grid[target_row,index,5,2]==winning_number:
            for i in(0,1,2):
                if game_grid[target_row,index,2-j,j]==0:

                        return (target_row,index,2-j,j)
    if type==3:
        if index==1:
            for i in(0,1,2):

                if game_grid[i,i,5,2]==0:
                    target_index=i


            for i in (0,1,2):
                if game_grid[target_index,target_index,3,i]==winning_number:
                    for j in(0,1,2):
                        if game_grid[target_index,target_index,i,j]==0:

                                return (target_index,target_index,i,j)
            for i in (0,1,2):
                if game_grid[target_index,target_index,4,i]==winning_number:
                    for j in(0,1,2):
                        if game_grid[target_index,target_index,j,i]==0:

                                return (target_index,target_index,j,i)
            if game_grid[target_index,target_index,5,1]==winning_number:
                for i in(0,1,2):
                    if game_grid[target_index,target_index,i,i]==0:

                            return (target_index,target_index,i,i)
            if game_grid[target_index,target_index,5,2]==winning_number:
                for i in(0,1,2):
                    if game_grid[target_index,target_index,2-j,j]==0:

                            return (target_index,target_index,2-j,j)
        if index==2:
            for i in(0,1,2):
                if game_grid[2-i,i,5,2]==0:
                    target_index=i

            for i in (0,1,2):
                if game_grid[2-target_index,target_index,3,i]==winning_number:
                    for j in(0,1,2):
                        if game_grid[2-target_index,target_index,i,j]==0:

                                return (2-target_index,target_index,i,j)
            for i in (0,1,2):
                if game_grid[2-target_index,target_index,4,i]==winning_number:
                    for j in(0,1,2):
                        if game_grid[2-target_index,target_index,j,i]==0:

                                return (2-target_index,target_index,j,i)
            if game_grid[2-target_index,target_index,5,1]==winning_number:
                for i in(0,1,2):
                    if game_grid[2-target_index,target_index,i,i]==0:

                            return (2-target_index,target_index,i,i)
            if game_grid[2-target_index,target_index,5,2]==winning_number:
                for i in(0,1,2):
                    if game_grid[2-target_index,target_index,2-j,j]==0:

                            return (2-target_index,target_index,2-j,j)

    return None

def check_path(node, correct_path):
    path_visits=[]
    path_visits.append(node.visits)
    on_right_track=True
    for i in range (0,correct_path.__len__()):
        if on_right_track:
            if node.children[correct_path[i]] is not None:
                current_visits=node.children[correct_path[i]].visits
                path_visits.append(current_visits)
                #print(path_visits)
                node=node.children[correct_path[i]]
            else:
                path_visits.append(0)
                on_right_track=False
        else:
            path_visits.append(0)
    return path_visits

#does a DFS to get all the visit counts of nodes at depth n
def get_visits_depth(node,n,all_visits):

    if n == 0:

        all_visits[0]+=1
        all_visits.append(node.visits)
    else:
        current_visits=0
        for i in (0,1,2):
            for j in (0,1,2):
                for k in (0,1,2):
                    for l in (0,1,2):

                        if node.children[i,j,k,l] is not None:
                            current_visits+=1
                            get_visits_depth(node.children[i,j,k,l],n-1,all_visits)

    return all_visits

def MCTS(active_node):


    #gets either a 2-tuple or a 4-tuple depending on whether "active_node"
    #is a free or constrained move node
    #chooses a move from available moves

    if use_decisive:
        move = check_decisive_whole_grid(active_node)
        if move ==None:
            move = active_node.get_ucb_move()

    else:
        move = active_node.get_ucb_move()
        if move==(2,2,1,2):
            pass



    #if the chosen move has already been explored
    if active_node.has_child(move):

        #run a game and update the node

        current_node=active_node.get_child(move)
        if not isinstance(current_node,node):
            for i in (0,1,2):
                for j in(0,1,2):
                    print("row ",i, "col ",j)
                    print(active_node.children[i,j,:,:])
            print_game(active_node.game_grid)
            print(move)

        if current_node.game_grid[5,2,5,2]==2 or current_node.game_grid[5,2,5,2]==-2:
            winner=current_node.game_grid[5,2,5,2]/2

            backpropogate(current_node,winner)

        elif current_node.game_grid[5,2,5,2]== 3:
            winner=0

            backpropogate(current_node,winner)
        else:
            MCTS(current_node)

    #if we have never tried this move
    else:
        #this is the point where a winner might be determined. When a node is made, check if it is a won state
        #0 indicates nothing happened, 1 or -1 indicates a small board was won, 2 or -2 indicates the game was won. 3 means the whole game is drawn


        has_player_won=active_node.make_child(move)


        active_node=active_node.get_child(move)


        if has_player_won==2 or has_player_won==-2:
            winner = has_player_won/2

            backpropogate(active_node,winner)
        elif has_player_won==3:
            winner=0

            backpropogate(active_node,winner)
        else:
            #1 if X wins, -1 if O wins, 0 if draw
            if use_decisive:
                move = check_decisive_whole_grid(active_node)
                if move ==None:
                    move = active_node.get_ucb_move()
            else:
                move= active_node.get_ucb_move()

            temp_active_node=copy(active_node)
            (winner,length,x_moves,o_moves)=temp_active_node.random_game(move)
            if Weighted_smart:
                update_weight=int(20/length)
                if RAVE_cutoff or RAVE_smooth:
                    
                    for i in range(update_weight):
                        if winner==0:
                            RAVE_backpropogate(active_node,winner,x_moves,o_moves)
                        else:
                            RAVE_backpropogate(active_node,winner,x_moves,o_moves)

                else:
                    for i in range(update_weight):
                        backpropogate(active_node,winner)
            if use_weighted_simulations or use_weighted_smooth:
                if use_weighted_simulations:
                    weighting_factor=1/length
                else:
                    weighting_factor=pow(2,-math.pow(length,2)/1500)
                if AMAF:
                    if winner==0:
                        AMAF_backpropogate(active_node,winner,moves)
                    else:
                        AMAF_backpropogate(active_node,winner*weighting_factor,moves)
                elif RAVE_cutoff or RAVE_smooth:
                    if winner==0:
                        RAVE_backpropogate(active_node,winner,x_moves,o_moves)
                    else:
                        RAVE_backpropogate(active_node,winner*weighting_factor,x_moves,o_moves)
                else:
                    if winner==0:
                        backpropogate(active_node,winner)
                    else:
                        backpropogate(active_node,winner*weighting_factor)
            else:
                if AMAF:
                    if winner==0:
                        AMAF_backpropogate(active_node,winner,moves)
                    else:
                        AMAF_backpropogate(active_node,winner,moves)
                elif RAVE_cutoff or RAVE_smooth:

                    if winner==0:
                        RAVE_backpropogate(active_node,winner,x_moves,o_moves)
                    else:
                        RAVE_backpropogate(active_node,winner,x_moves,o_moves)
                else:
                    if winner==0:
                        backpropogate(active_node,winner)
                    else:
                        backpropogate(active_node,winner)






if __name__ == '__main__':
    main()